100 REMark Pagination Program, by Dilwyn Jones 28/9/96
110 REMark $$asmb=win1_bootup_qlib_ext,0,12
120 REMark $$asmb=win1_bootup_djtoolkit_bin,0,12
130 REMark $$asmb=win1_bootup_edline_code,0,10
140 REMark $$asmb=flp1_Paginator_cfg,0,12
150 :
160 REMark config block goes here
170 def_drive$  = C_STRG$(1) : REMark file input from
180 def_op$     = C_STRG$(2) : REMark print output to
190 def_lpp%    = C_WORD(1)  : REMark lines per page
200 def_tm%     = C_WORD(2)  : REMark top margin
210 def_bm%     = C_WORD(3)  : REMark bottom margin
220 def_lm%     = C_WORD(4)  : REMark left margin, in characters
230 view_pause% = C_WORD(5)  : REMark for error messages etc (in seconds)
240 sound_on%   = C_CODE(1)  : REMark error beeps etc
250 backg%      = C_CODE(2)  : REMark suppress printing messages
260 :
270 REMark if job is <> 0, either compiled or a basic which can open #0
280 IF Q_MYJOB <> 0 : OPEN #0,con
290 :
300 IF SCREEN_MODE <> 4 AND SCREEN_MODE <> 0 THEN 
310   MODE 4
320   IF SCREEN_MODE <> 4 AND SCREEN_MODE <> 0 THEN 
330     PRINT #0,'Unable to change to MODE 4!'
340     PAUSE 50*view_pause% : STOP
350   END IF 
360 END IF 
370 :
380 WINDOW #0,448,62,32,100 : BORDER #0,1,255
390 INK #0,7 : PAPER #0,0
400 :
410 REMark check configured information
420 IF def_tm% >= def_lpp% THEN 
430   IF sound_on% = 1 THEN BEEP 5000,50
440   PRINT #0,'Top margin out of range.' : PAUSE 50*view_pause% : STOP
450 END IF 
460 :
470 IF def_bm% >= def_lpp% THEN 
480   IF sound_on% = 1 THEN BEEP 5000,50
490   PRINT #0,'Bottom margin out of range.' : PAUSE 50*view_pause% : STOP
500 END IF 
510 :
520 IF def_tm%+def_bm% >= def_lpp% THEN 
530   IF sound_on% = 1 THEN BEEP 5000,50
540   PRINT #0,'Top and bottom margin combined out of range.'
550   PAUSE 50*view_pause% : STOP
560 END IF 
570 :
580 REPeat program
590   CLS #0
600   PAPER #0,2 : CLS #0,3 : AT #0,0,19
610   PRINT #0,'PAGINATOR V';C_VERS$;', BY DILWYN JONES 1996'
620   PAPER #0,0
630   PRINT #0,'Enter name of text file to print > ';
640   p$ = EDLINE$(#0,41,def_drive$)
650   IF p$ = '' THEN EXIT program
660   def_drive$ = p$
670   :
680   PRINT #0,'Print file to > ';
690   o$ = EDLINE$(#0,41,def_op$)
700   IF o$ = '' THEN NEXT program
710   def_op$ = o$
720   :
730   REPeat loop
740     PRINT #0,'How many lines per page ? ';
750     p$ = EDLINE$(#0,3,def_lpp%)
760     IF p$ = '' THEN NEXT program
770     loop = '0'&p$
780     IF loop < 1 OR loop > 999 THEN 
790       IF sound_on% = 1 THEN BEEP 5000,50
800       PRINT #0,'Invalid entry.'
810       PAUSE 50*view_pause% : NEXT loop
820     END IF 
830     def_lpp% = loop : EXIT loop
840   END REPeat loop
850   :
860   REPeat loop
870     PRINT #0,'Enter top margin lines > ';
880     p$ = EDLINE$(#0,3,def_tm%)
890     IF p$ = '' THEN NEXT program
900     loop = '0' & p$
910     IF (loop = 0 AND p$ <> '0') OR loop < 0 OR loop > 999 OR loop >= def_lpp% THEN 
920       IF sound_on% = 1 THEN BEEP 5000,50
930       PRINT #0,'Invalid entry.'
940       PAUSE 50*view_pause% : NEXT loop
950     END IF 
960     def_tm% = loop : EXIT loop
970   END REPeat loop
980   :
990   REPeat loop
1000     PRINT #0,'Enter bottom margin lines > ';
1010     p$ = EDLINE$(#0,3,def_bm%)
1020     IF p$ = '' THEN NEXT program
1030     loop = '0'&p$
1040     IF (loop = 0 AND p$ <> '0') OR loop < 0 OR loop > 999 OR loop >= (def_lpp%-def_tm%) THEN 
1050       IF sound_on% = 1 THEN BEEP 5000,50
1060       PRINT #0,'Invalid entry.'
1070       PAUSE 50*view_pause% : NEXT loop
1080     END IF 
1090     def_bm% = loop : EXIT loop
1100   END REPeat loop
1110   :
1120   REPeat loop
1130     PRINT #0,'Enter left margin (in characters) > ';
1140     p$ = EDLINE$(#0,3,def_lm%)
1150     IF p$ = '' THEN NEXT program
1160     loop = '0'&p$
1170     IF (loop = 0 AND p$ <> '0') OR loop < 0 OR loop > 80 THEN 
1180       IF sound_on% = 1 THEN BEEP 5000,50
1190       PRINT #0,'Invalid entry.' : PAUSE 50*view_pause% : NEXT loop
1200     END IF 
1210     def_lm% = loop : EXIT loop
1220   END REPeat loop
1230   REMark we now have the necessary entries, try the file...
1240   Q_ERR_ON 'open_in' : OPEN_IN #3,def_drive$
1250   fer = Q_ERR : Q_ERR_OFF 'open_in'
1260   IF fer < 0 THEN 
1270     IF sound_on% = 1 THEN BEEP 5000,50
1280     PRINT #0,Q_Err$ (fer)
1290     PAUSE 50*view_pause%
1300     NEXT program
1310   END IF 
1320   :
1330   REMark shorten name to new default drive
1340   op$ = def_drive$ : fp = '_' INSTR def_drive$
1350   IF (fp = 3 OR fp = 4) AND def_drive$(1) INSTR 'abcdefghijklmnopqrstuvwxyz' THEN 
1360     REMark probably a network name, if so we need to extract the
1370     REMark network station and drive name (up to second '_')
1380     IF def_drive$(2) INSTR '1234567890' THEN 
1390       IF def_drive$(3) INSTR '1234567890_' THEN 
1400         REMark yes, a network name
1410         IF LEN(def_drive$) > fp THEN 
1420           fp2 = '_' INSTR def_drive$(fp+1 TO LEN(def_drive$))
1430           IF fp2 > 0 THEN fp = fp2
1440         END IF 
1450       END IF 
1460     END IF 
1470   END IF 
1480   IF fp : def_drive$ = def_drive$(1 TO fp)
1490   :
1500   REMark try the output too... (may be output to file)
1510   Q_ERR_ON 'open_new' : OPEN_NEW #4,def_op$
1520   fer = Q_ERR : Q_ERR_OFF 'open_new'
1530   IF fer < 0 THEN 
1540     IF sound_on% = 1 THEN BEEP 5000,50
1550     PRINT #0,Q_Err$(fer)
1560     PAUSE 50*view_pause%
1570     CLOSE #3 : NEXT program
1580   END IF 
1590   :
1600   REMark Toolkit 2 overwrite y/n? prompts may get us mixed up here
1610   REMark if 'n' was selected, the file may still not be open...
1620   Q_ERR_ON 'print' : PRINT #4,'';
1630   fer = Q_ERR : Q_ERR_OFF 'print'
1640   IF fer < 0 THEN 
1650     IF sound_on% = 1 THEN BEEP 5000,50
1660     PRINT #0,Q_Err$(fer)
1670     PAUSE view_pause%*50
1680     CLOSE #3 : NEXT program
1690   END IF 
1700   :
1710   REMark At last... here we go!
1720   line_no = 0   : REMark total lines printed
1730   page_line = 0 : REMark lines printed this page
1740   page_no = 1   : REMark always starts with page 1
1750   CLS #0 : INK #0,4 : PRINT #0,'PAGINATOR IS PRINTING ';op$
1760   INK #0,7
1770   IF backg% = 0 THEN 
1780     AT #0,1,0 : PRINT #0,'LINE:0';
1790     AT #0,2,0 : PRINT #0,'PAGE:1';
1800   END IF 
1810   REMark FOR a = 1 TO def_tm% : PRINT #4,
1820   REMark page_line% = def_tm% : line_no = def_tm%
1830   REMark AT #0,1,5 : PRINT #0,line_no
1840   Q_ERR_ON 'input'
1850   lm$ = FILL$(' ',def_lm%)
1860   REPeat printout
1870     IF EOF(#3) : EXIT printout
1880     IF backg% = 0 : AT #0,2,5 : PRINT #0,page_no
1890     fp = FILE_POSITION (#3)
1900     INPUT #3,t$ : fer = Q_ERR
1910     IF fer < 0 THEN 
1920       IF fer = -10 THEN 
1930         REMark end of file error happens when end LF missing
1940         IF sound_on% = 1 THEN BEEP 5000,20
1950         ABS_POSITION #3,fp : t$ = ''
1960         REPeat loop
1970           IF EOF(#3):EXIT loop
1980           t$ = t$&INKEY$(#3)
1990         END REPeat loop
2000       ELSE 
2010         IF sound_on% = 1 THEN BEEP 5000,50
2020         AT #0,4,0 : PRINT #0,Q_Err$(fer)
2030         PAUSE 50*view_pause%
2040         CLOSE #3 : CLOSE #4 : NEXT program
2050       END IF 
2060     END IF 
2070     IF page_line = 0 THEN 
2080       REMark send top of page spacing
2090       FOR a = 1 TO def_tm% : PRINT #4,
2100       page_line = def_tm% : line_no = line_no + def_tm%
2110       IF backg% = 0 : AT #0,1,5 : PRINT #0,line_no
2120     END IF 
2130     line_no = line_no + 1
2140     IF backg% = 0 : AT #0,1,5 : PRINT #0,line_no
2150     REMark PRINT #4,t$ : page_line = page_line + 1
2160     ff% = CHR$(12) INSTR t$
2170     IF ff% = 0 THEN 
2180       PRINT #4,lm$;t$ : page_line = page_line + 1
2190     ELSE 
2200       REMark print up to the form feed...
2210       PRINT #4,lm$;t$(1 TO ff%);
2220       page_no = page_no + 1 : REMark AT #0,2,5 : PRINT #0,page_no
2230       page_line = 0 : REMark assume new page
2240       IF ff% < LEN(t$) THEN 
2250         PRINT #4,t$(ff%+1 TO LEN(t$));
2260         page_line = page_line + 1
2270       END IF 
2280       PRINT #4, : REMark end of line LF
2290       line_no = page_no*def_lpp%
2300       IF backg% = 0 : AT #0,1,5 : PRINT #0,line_no
2310       NEXT program
2320     END IF 
2330     :
2340     IF (page_line-def_tm%) >= (def_lpp%-def_tm%-def_bm%) THEN 
2350       REMark reached end of page, add bottom margin
2360       FOR a = 1 TO def_bm% : PRINT #4,
2370       line_no = line_no + def_bm%
2380       IF backg% = 0 : AT #0,1,5 : PRINT #0,line_no
2390       page_no = page_no + 1 : REMark AT #0,2,5 : PRINT #0,page_no
2400       page_line = 0
2410     END IF 
2420   END REPeat printout
2430   Q_ERR_OFF 'input' : CLOSE #3 : CLOSE #4
2440   IF backg% = 1 AND sound_on% = 1 : BEEP 30000,10,30,1400,1
2450   AT #0,4,0 : PRINT #0,'Page Printing Finished.'
2460   PAUSE 50*view_pause%
2470 END REPeat program
2480 :
2490 CLS #0 : PRINT #0,'Program Finished.'
2500 PAUSE 50*view_pause%
2510 :
2520 REMark $$off
2530 WTV 4 : REMark reset superbasic windows
2540 REMark $$on
2550 :
2560 STOP
2570 :
2580 DEFine FuNction Q_Err$ (fe)
2590   LOCal e
2600   e = fe
2610   SELect ON e
2620     =0   : RETurn ""
2630     =-1  : RETurn "not complete"
2640     =-2  : RETurn "invalid job"
2650     =-3  : RETurn "out of memory"
2660     =-4  : RETurn "out of range"
2670     =-5  : RETurn "buffer overflow"
2680     =-6  : RETurn "channel not open"
2690     =-7  : RETurn "not found"
2700     =-8  : RETurn "already exists"
2710     =-9  : RETurn "in use"
2720     =-10 : RETurn "end of file"
2730     =-11 : RETurn "drive full"
2740     =-12 : RETurn "bad name"
2750     =-13 : RETurn "transmission error"
2760     =-14 : RETurn "format failed"
2770     =-15 : RETurn "bad parameter"
2780     =-16 : RETurn "file error"
2790     =-17 : RETurn "error in expression"
2800     =-18 : RETurn "arithmetic overflow"
2810     =-19 : RETurn "not implemented"
2820     =-20 : RETurn "read only"
2830     =-21 : RETurn "bad line"
2840     =REMAINDER : RETurn "error "&e
2850   END SELect 
2860 END DEFine Q_Err$
2870 :
2880 REMark $$off
2890 DEFine PROCedure Sa
2900   QSAVE flp1_Paginator : QSAVE flp2_Paginator
2910   SAVE flp1_paginator_bas : SAVE flp2_paginator_bas
2920 END DEFine Sa
2930 REMark $$on
2940 :
